function MroApi(base_url, api_user, api_password, company_id)
{
    this.base_url = base_url;
    this.authentication_user = api_user;
    this.authentication_key = api_password;
    
    this.session_id = null;
    this.company_id = company_id;
    
    this.identified = false;
    this.logged_in = false;
}


MroApi.prototype.identify = function(on_identify)
{
    var self = this;
    $.get(this.base_url + '/api/authenticate/' + this.authentication_user + '/' + this.authentication_key + '/' + this.company_id, function(data)
    {
        var result = JSON.parse(data);
        if(result.success === true)
        {
            self.identified = true;
            self.session_id = result.session_id;
            window.localStorage.setItem('session_id', self.session_id);
            
            
            on_identify();
        }
        else
        {
            self.identified = false;
        }
    });
};


MroApi.prototype.login_alt = function(on_login_success, on_login_fail)
{
    var reservation_number = window.localStorage.getItem('reservation_number');
    var postal_code = window.localStorage.getItem('postal_code');
    
    if(reservation_number === null || postal_code === null)
    {
        this.logged_in = false;
        if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
        return;
    }
    
    
    var self = this;
    $.post(this.base_url + '/api/user_login_alt', {session_id: this.session_id, company_id: this.company_id, reservation_number: reservation_number, postal_code: postal_code}, function(data)
    {
        alert(data);
        var result = JSON.parse(data);
        if(result.success === true)
        {
            self.logged_in = true;
            alert('Logged in.');
            if(on_login_success && typeof(on_login_success) === 'function') on_login_success();
        }
        else
        {
            self.logged_in = false;
            alert('Nog logged in.');
            if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
        }
    }).fail(function()
    {
        self.logged_in = false;
        if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
    });
}


MroApi.prototype.login = function(on_login_success, on_login_fail)
{
    var first_name = window.localStorage.getItem('first_name');
    var last_name = window.localStorage.getItem('last_name');
    var age = window.localStorage.getItem('age');
    var sex = window.localStorage.getItem('sex');
    var email = window.localStorage.getItem('email');

    if(first_name === null || last_name === null || email === null)
    {
        this.logged_in = false;
        if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
        return;
    }
    
    
    
    var self = this;
    $.post(this.base_url + '/api/user_login', {session_id: this.session_id, first_name: first_name, last_name: last_name, age: age, sex: sex, email: email, company_id: this.company_id}, function(data)
    {
        var result = JSON.parse(data);
        if(result.success === true)
        {
            self.logged_in = true;
            if(on_login_success && typeof(on_login_success) === 'function') on_login_success();
        }
        else
        {
            self.logged_in = false;
            
            if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
        }
    }).fail(function()
    {
        self.logged_in = false;
        if(on_login_fail && typeof(on_login_fail) === 'function') on_login_fail();
    });
};


MroApi.prototype.register_device = function(type, identifier, token, on_register)
{
    $.post(this.base_url + '/api/register_device', {session_id: this.session_id, type: type, identifier: identifier, token: token}, function(data)
    {
        try
        {
            var result = JSON.parse(data);
            if(result.success === true)
            {
                on_register();
            }
            else
            {
                //on_fail();
            }
        }
        catch(e)
        {
            //on_fail();
        }
    }).fail(function()
    {
        //on_fail();
    });
};


MroApi.prototype.get_cms_data = function(on_get_cms_data)
{
    var post_params = {session_id: this.session_id};
    
    if(this.company_id !== null)
    {
        //alert(this.company_id);
        post_params['company_id'] = this.company_id;
    }
    
    $.post(this.base_url + '/api/get_cms_data', post_params, function(data)
    {
        //alert(data);
        var result = JSON.parse(data);
        if(result.success === true)
        {
            window.localStorage.setItem('cms_data', JSON.stringify(result.cms_data));
            if(on_get_cms_data && typeof(on_get_cms_data) === 'function') on_get_cms_data();
        }
        else
        {
            //alert(data);
        }
    }).fail(function()
    {
    });
};


MroApi.prototype.get_messages = function(on_get_messages)
{
    $.post(this.base_url + '/api/get_messages', {session_id: this.session_id}, function(data)
    {
        var result = JSON.parse(data);
        if(result.success === true)
        {
            window.localStorage.setItem('messages', JSON.stringify(result.messages));
            if(on_get_messages && typeof(on_get_messages) === 'function') on_get_messages();
        }
        else
        {
        }
    }).fail(function()
    {
    });
};


MroApi.prototype.read_all = function()
{
    $.post(this.base_url + '/api/read_all', {session_id: this.session_id}, function()
    {
    });
}


MroApi.prototype.logout = function(on_logout)
{
    $.post(base_url + '/api/remove_device', {session_id: session_id, type: device_type, token: regid}, function()
    {
        if(on_logout && typeof(on_logout) === 'function') on_logout();
    }).fail(function(){
        if(on_logout && typeof(on_logout) === 'function') on_logout();
    });
};