var identified = null;
var session_id = null;
var regid = null;
var device_type = null;

var username = null;
var password = null;
var logged_in = false;


var mro_api = null;
var mro_notification = null;
var mro_mijn = null;
var mro_stratech = null;


document.addEventListener("deviceready", onDeviceReady, false);


function openNew(link)
{
    navigator.app.loadUrl(link, { 'openExternal' : true });
}

function global_error_handler(error)
{
    //alert('Error: ' + error);
    // To-do: Parse error.
}

function onBackKeyDown()
{
    if($("#info_page").is(':visible')) {
        if(document.getElementById('iframe_info_content').contentWindow.document.referrer === '')
        {
            navigator.app.exitApp();
        }
        else
        {
            // iframe laten weten dat de lader getoond moet worden
            var iframe = document.getElementById('iframe_info_content');
            var url = iframe.contentWindow.location.href;
            // Announce that we have a camera.
            iframe.contentWindow.postMessage({
                loading: true
            }, url);

            window.history.back();
        }
    }
    else if($("#iframe_content_mro").is(':visible')) {
        if(document.getElementById('iframe_content_mro').contentWindow.document.referrer === '')
        {
            navigator.app.exitApp();
        }
        else
        {
           window.history.back();
        }
    }
    else {
        navigator.app.exitApp();
    }
}

function onDeviceReady()
{
    $(document).on("click", ".detail_page .content img", function(e) {
        $(this).toggleClass("full_image");
    });


    $(document).on("click", "#info", function(e) {
        var myClass = this.className;
        if(myClass == "tab_button first_tab active_tab" || myClass == "tab_button active_tab") {

            // iframe laten weten dat de lader getoond moet worden
            var iframe = document.getElementById('iframe_info_content');
            var url = iframe.contentWindow.location.href;
            // Announce that we have a camera.
            iframe.contentWindow.postMessage({
                loading: true
            }, url);

            // if the info button is pressed again we reload the info iFrame
            var language = window.localStorage.getItem('language');
            $("#iframe_info_content").attr('src', base_iframe_url + company_name + '/info.php?language=' + language + '&device_id=' + device.platform+'::'+device.uuid);
        }
    });


    document.addEventListener("backbutton", onBackKeyDown, true);

    $('#info_page #back_button').click(function(){
        close_detail_page(true);
    });

    var language = window.localStorage.getItem('language');
    if(language === null)
    {
        language = navigator.language.split('-')[0];
        if (language == 'en') {language = 'nl';}
        switch(language)
        {
            case 'nl':
            case 'de':
                i18n.init({ lng: language, resGetPath: 'base/locales/__lng__/__ns__.json' }, function()
                {
                    $('body').i18n();
                });
                window.localStorage.setItem('language', language);
                break;
                
            default:
                i18n.init({ lng: 'nl', resGetPath: 'base/locales/__lng__/__ns__.json' }, function()
                {
                    $('body').i18n();
                });
                //show_div('#choose_language','Settings');
                window.localStorage.setItem('language', language);
                break;
        }
    }

    $('img.change_language').attr('src', 'base/img/flags/' + language + '2.png');
    i18n.init({ lng: language, resGetPath: 'base/locales/__lng__/__ns__.json' }, function(t){
        $('body').i18n();
    });
    if(navigator.network !== undefined){
        if(navigator.network.connection.type !== Connection.NONE)
        {
            init();
        }
        else
        {
            var last_update = window.localStorage.getItem('last_update');
            var alertString = 'Geen internet vervinding, laatste bijgewerkt op <br />'+last_update;
            set_alert(alertString, 0);
            if(window.localStorage.getItem('cms_data') === null)
            {
                show_div('#main','Info');
            }
            else
            {
                show_div('#main','Info');
                load_cached_data();
            }
            build_menu();
        }
    }
    else
    {
        init();
    }
}

function build_menu()
{
    if(modules['messages'] || modules['mijnomgeving'] || modules['account'] || modules['language'])
    {
        // Only give the 'first_tab' class to the first button when there are less than 4 tabs.
        //var first = (modules['messages'] && modules['info'] && modules['mijnomgeving'] && modules['account']) ? 1 : 0;
        var first = (modules['info'] && modules['mijnomgeving'] && modules['language']) ? 1 : 0;
        var html =
                (modules['messages'] ? '<div class="tab_button' + (first++ ? '' : ' first_tab') + '" id="messages"><i class="flaticon-double7"></i></br><span data-i18n="menu.messages"></span></div>' : '')
                + (modules['info'] ? '<div class="tab_button active_tab' + (first++ ? '' : ' first_tab') + '" id="info"><i class="flaticon-information22"></i><br /><span data-i18n="menu.info"></span></div>' : '')
                + (modules['mijnomgeving'] ? '<div class="tab_button' + (first++ ? '' : ' first_tab') + '" id="mijnrecreatieomgeving"><i class="ownicon-logomijnrec"></i><br /><span data-i18n="menu.my"></span></div>' : '')
                + (modules['language'] ? '<div class="tab_button' + (first++ ? '' : ' first_tab') + '" id="account"><i class="flaticon-machine"></i><br /><span data-i18n="menu.account"></span></div>' : '')

        $("#tab_bar").html(html);

        $(".tab_button").click(function(){
            var tab = $(this).attr('id');
            show_tabpage('#'+tab+'_page', tab, tab);
        });
    }
    else {
        $("#tab_bar").hide();
    }
    $('#tab_bar, .tab_button').css('background-color', menu_color);
}


function handle_modules()
{
    if(!modules['messages'])
    {
        $('#messages_button').hide();
    }
    if(!modules['info'])
    {
        $('#info_button').hide();
    }
    if(!modules['mijnomgeving'])
    {
        $('#mijnomgeving_button').hide();
    }
    if(!modules['account'])
    {
        $('#account_button').hide();
    }
}


function init()
{
    handle_modules();
    if(device.platform === 'android' || device.platform === 'Android')
    {
        device_type = 'android';
    }
    else
    {
        device_type = 'ios';
    }

    build_menu();

    var language = window.localStorage.getItem('language');

    $("#iframe_info_content").attr('src', base_iframe_url + company_name + '/info.php?language=' + language + '&device_id=' + device.platform+'::'+device.uuid);
    $("#iframe_content_mro").attr('src', my_environment_url + '/' + language + '/mijn/');
    
    var iframe = document.getElementById('iframe_content_mro');

    // iframe laten weten dat de lader getoond moet worden
    var iframe_content = document.getElementById('iframe_info_content');
    show_div('#main','Info');
}


function on_register()
{
    mro_api.register_device(device_type, device.platform + '::' + device.uuid, this.token, on_api_register);
}


function on_api_register()
{
    //alert('Device registered to our server!');

}


function on_message()
{
    mro_api.get_messages(function(){
        load_cached_data();
        show_tabpage('#messages_page', 'Berichten', 'Berichten');
        $.mobile.silentScroll();
    });
}


function show_div(selector, navigationtext)
{
    $('#choose_language').hide();
    $('#main').hide();
    $('#login').hide();
    $('#loading').hide();
    change_navigationbar_text(navigationtext, '.container');
    $(selector).show();
}



function show_tab(selector)
{
    $('.icon-circle-arrow-down').switchClass('icon-circle-arrow-down', 'icon-circle-arrow-right');
    $(selector + ' .icon-circle-arrow-right').switchClass('icon-circle-arrow-right', 'icon-circle-arrow-down');
    $('li.active').removeClass('active');
    $('.content').hide();
    $(selector).show();
    $(selector + ':first').addClass('active');
}

function show_tabpage(selector, navigationtext, button_class){
    $('#messages_page').hide();
    $('#info_page').hide();
    $('#mijnrecreatieomgeving_page').hide();
    $('#account_page').hide();
    change_navigationbar_text(navigationtext, '.container');
    // TODO: Maak deze mooier, makkelijk als er met events gewerkt wordt
    $('.tab_button').removeClass('active_tab');
    $('#' + button_class).addClass('active_tab');

    $(selector).show();
}


function choose_language(language)
{
    window.localStorage.setItem('language', language);

    i18n.init({ lng: language, resGetPath: 'base/locales/__lng__/__ns__.json' }, function()
    {
        $('body').i18n();
    });
    window.localStorage.setItem('language', language);
    build_menu();
    show_tabpage('#account_page', 'account', 'account');
    $("#iframe_info_content").attr('src', base_iframe_url + company_name + '/info.php?language=' + language + '&device_id=' + device.platform+'::'+device.uuid);
    $("#iframe_content_mro").attr('src', my_environment_url + '/' + language + '/mijn/');
}




function successHandler(result)
{
    //alert('result = ' + result);
}

function errorHandler(error)
{
    //alert('error = ' + error);
}


function load_cached_data()
{
    show_messages();

    var cms_data = JSON.parse(window.localStorage.getItem('cms_data'));

    $('#info_page .info_menu').empty();
    $.each(cms_data, function(key, value){
        $('#info_page .info_menu').append('<li><a href="javascript:show_detail_page('+key+', true);">' + value.name + '<i class="ownicon-arrow"></i></a></li>');
    });

    var mijnrec_data = JSON.parse(window.localStorage.getItem('mijnrecreatie_data'));

    $('#mijnrecreatieomgeving_page .info_menu').empty();
    $.each(mijnrec_data, function(key, value) {
        $('#mijnrecreatieomgeving_page .info_menu').append('<li style="background: ' + value.color + '"><a href="javascript:show_detail_page(' + key + ', false, \'' + value.color + '\');"><img src="' + value.logo + '" alt=""/>' + value.name + '<i class="ownicon-arrow"></i></a></li>');
    });
}

function change_navigationbar_text(text, page, color){
    if(color !== undefined){
        $(page + ' > .navigation_bar').css('background', color);
    }
    $(page + ' > .navigation_bar .nav_title').empty();
    $(page + ' > .navigation_bar .nav_title').append(text);
}

function show_detail_page(key, is_cms_data,color){
    var data;
    var detail_page;

    if(is_cms_data){
        data = JSON.parse(window.localStorage.getItem('cms_data'))[key];
        detail_page = '#info_page';
    }
    else{
        data = JSON.parse(window.localStorage.getItem('mijnrecreatie_data'))[key];
        detail_page = '#mijnrecreatieomgeving_page';
    }

    $(detail_page + ' .detail_page > .content').append(data.text);
    $(detail_page + ' .detail_page > .content').append("<script type='text/javascript'>$('.content a').click(function () { window.open( $(this).attr('href'), '_system' ); return false; });</script>");
    change_navigationbar_text(data.name, detail_page + ' .detail_page', color);
    $(detail_page + ' .menu').hide();
    $(detail_page + ' .detail_page').show();
}

function close_detail_page(is_cms_data){
    var detail_page;
    if(is_cms_data){
        detail_page = '#info_page';
    }
    else{
        detail_page = '#mijnrecreatieomgeving_page';
    }
    $(detail_page + ' .detail_page > .content').empty();
    $(detail_page + ' .menu').show();
    $(detail_page + ' .detail_page').hide();
}

function show_alert(txt)
{
    $('#alert_box').html(txt);
    $('#alert_box').show();
    $('#alert_box').fadeOut().delay(3000);
}

function show_messages()
{
    var messages = JSON.parse(window.localStorage.getItem('messages'));
    if(messages === null || messages.length < 1)
    {
        return;
    }

    $('#messages_page').empty();
    $.each(messages, function(key, value){
        $('#messages_page').append('<div class="chat_date"><section>' + value.human_date + '</section></div>');
        $.each(value.messages, function(key, value){
            var append_text;
            if(value.user_message === '1'){
                append_text = '<div class="message_balloon_user">';
            }
            else{
                append_text = '<div class="message_balloon_camping">';
            }
            append_text = append_text + value.message + '<section class="time_sent">' + value.human_time + '</section></div>';
            $('#messages_page').append(append_text);
        });
    });
}

function set_alert(text, delay)
{

    $('#top-alert-text').html(text);
    $( "#top-alert" ).slideUp( 300, function() {$("#main").css('margin-top', '50px');} ).fadeIn( 400);
    if(delay !== 0) {
        $( "#top-alert" ).slideDown( 300 ).delay( delay ).fadeOut(400, function() {$("#main").css('margin-top', '0px');});
    }
}

